Index: c/src/lib/libbsp/lm32/lm32_evr/ChangeLog
===================================================================
--- c/src/lib/libbsp/lm32/lm32_evr/ChangeLog	(revision e44ffe5e1e029969d90c1e368d3156ac48de76c2)
+++ c/src/lib/libbsp/lm32/lm32_evr/ChangeLog	(revision e44ffe5e1e029969d90c1e368d3156ac48de76c2)
@@ -0,0 +1,7 @@
+2008-12-04	Jukka Pietarinen <jukka.pietarinen@mrf.fi>
+
+	* ChangeLog, Makefile.am, bsp_specs, configure.ac, preinstall.am,
+	include/.cvsignore, include/bsp.h, include/coverhd.h,
+	include/irq-config.h, include/system_conf.h, include/tm27.h,
+	startup/linkcmds: New files.
+
Index: c/src/lib/libbsp/lm32/lm32_evr/Makefile.am
===================================================================
--- c/src/lib/libbsp/lm32/lm32_evr/Makefile.am	(revision e44ffe5e1e029969d90c1e368d3156ac48de76c2)
+++ c/src/lib/libbsp/lm32/lm32_evr/Makefile.am	(revision e44ffe5e1e029969d90c1e368d3156ac48de76c2)
@@ -0,0 +1,48 @@
+##
+## $Id$
+##
+
+ACLOCAL_AMFLAGS = -I ../../../../aclocal
+
+include $(top_srcdir)/../../../../automake/compile.am
+include $(top_srcdir)/../../bsp.am
+
+include_bspdir = $(includedir)/bsp
+
+dist_project_lib_DATA = bsp_specs
+
+include_HEADERS = include/bsp.h
+include_HEADERS += include/tm27.h
+
+nodist_include_HEADERS = include/bspopts.h
+nodist_include_bsp_HEADERS = ../../shared/include/bootcard.h
+DISTCLEANFILES = include/bspopts.h
+
+noinst_PROGRAMS =
+
+include_HEADERS += include/coverhd.h
+include_HEADERS += include/system_conf.h
+
+EXTRA_DIST = ../shared/start/start.S
+start.$(OBJEXT): ../shared/start/start.S
+	$(CPPASCOMPILE) -o $@ -c $<
+project_lib_DATA = start.$(OBJEXT)
+
+dist_project_lib_DATA += startup/linkcmds
+
+startup_SOURCES = ../../shared/bspclean.c ../../shared/bsplibc.c \
+    ../../shared/bsppost.c ../shared/startup/bspstart.c \
+    ../../shared/bsppretaskinghook.c ../../shared/bspgetworkarea.c \
+    ../../shared/bootcard.c ../../shared/sbrk.c ../shared/startup/setvec.c \
+    ../../shared/gnatinstallhandler.c
+clock_SOURCES = ../shared/clock/ckinit.c
+console_SOURCES = ../shared/console/console.c ../shared/console/uart.c
+network_SOURCES = ../shared/tsmac/tsmac.c
+timer_SOURCES = ../shared/timer/timer.c
+
+noinst_LIBRARIES = libbsp.a
+libbsp_a_SOURCES = $(startup_SOURCES) $(clock_SOURCES) $(console_SOURCES) \
+    $(network_SOURCES) $(timer_SOURCES)
+
+include $(srcdir)/preinstall.am
+include $(top_srcdir)/../../../../automake/local.am
Index: c/src/lib/libbsp/lm32/lm32_evr/bsp_specs
===================================================================
--- c/src/lib/libbsp/lm32/lm32_evr/bsp_specs	(revision e44ffe5e1e029969d90c1e368d3156ac48de76c2)
+++ c/src/lib/libbsp/lm32/lm32_evr/bsp_specs	(revision e44ffe5e1e029969d90c1e368d3156ac48de76c2)
@@ -0,0 +1,18 @@
+%rename lib old_lib
+%rename endfile old_endfile
+%rename startfile old_startfile
+%rename link old_link
+
+*lib:
+%{!qrtems: %(old_lib)} \
+%{!nostdlib: %{qrtems: %{!qnolinkcmds: -T linkcmds%s}}}
+
+*startfile:
+%{!qrtems: %(old_startfile)} \
+%{!nostdlib: %{qrtems: start.o%s crti.o%s crtbegin.o%s -e start}}
+
+*link:
+%{!qrtems: %(old_link)} %{qrtems: -dc -dp -N -e start}
+
+*endfile:
+%{!qrtems: %(old_endfile)} %{qrtems: crtend.o%s}
Index: c/src/lib/libbsp/lm32/lm32_evr/configure.ac
===================================================================
--- c/src/lib/libbsp/lm32/lm32_evr/configure.ac	(revision e44ffe5e1e029969d90c1e368d3156ac48de76c2)
+++ c/src/lib/libbsp/lm32/lm32_evr/configure.ac	(revision e44ffe5e1e029969d90c1e368d3156ac48de76c2)
@@ -0,0 +1,20 @@
+## Process this file with autoconf to produce a configure script.
+## 
+## $Id$
+
+AC_PREREQ(2.60)
+AC_INIT([rtems-c-src-lib-libbsp-lm32-lm32_evr],[_RTEMS_VERSION],[http://www.rtems.org/bugzilla])
+AC_CONFIG_SRCDIR([bsp_specs])
+RTEMS_TOP(../../../../../..)
+
+RTEMS_CANONICAL_TARGET_CPU
+AM_INIT_AUTOMAKE([no-define nostdinc foreign 1.10])
+RTEMS_BSP_CONFIGURE
+
+RTEMS_PROG_CC_FOR_TARGET([-ansi -fasm])
+RTEMS_CANONICALIZE_TOOLS
+RTEMS_PROG_CCAS
+
+# Explicitly list all Makefiles here
+AC_CONFIG_FILES([Makefile])
+AC_OUTPUT
Index: c/src/lib/libbsp/lm32/lm32_evr/include/.cvsignore
===================================================================
--- c/src/lib/libbsp/lm32/lm32_evr/include/.cvsignore	(revision e44ffe5e1e029969d90c1e368d3156ac48de76c2)
+++ c/src/lib/libbsp/lm32/lm32_evr/include/.cvsignore	(revision e44ffe5e1e029969d90c1e368d3156ac48de76c2)
@@ -0,0 +1,4 @@
+stamp-h
+stamp-h.in
+bspopts.h
+bspopts.h.in
Index: c/src/lib/libbsp/lm32/lm32_evr/include/bsp.h
===================================================================
--- c/src/lib/libbsp/lm32/lm32_evr/include/bsp.h	(revision e44ffe5e1e029969d90c1e368d3156ac48de76c2)
+++ c/src/lib/libbsp/lm32/lm32_evr/include/bsp.h	(revision e44ffe5e1e029969d90c1e368d3156ac48de76c2)
@@ -0,0 +1,81 @@
+/*  bsp.h
+ *
+ *  This include file contains all board IO definitions.
+ *
+ *  XXX : put yours in here
+ *
+ *  COPYRIGHT (c) 1989-1999.
+ *  On-Line Applications Research Corporation (OAR).
+ *
+ *  The license and distribution terms for this file may be
+ *  found in the file LICENSE in this distribution or at
+ *  http://www.rtems.com/license/LICENSE.
+ *
+ *  $Id$
+ *
+ *  Jukka Pietarinen <jukka.pietarinen@mrf.fi>, 2008,
+ *  Micro-Research Finland Oy
+ */
+
+#ifndef _BSP_H
+#define _BSP_H
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#include <stdint.h>
+#include <bspopts.h>
+
+#include <rtems.h>
+#include <rtems/console.h>
+#include <rtems/clockdrv.h>
+
+#define BSP_GET_WORK_AREA_DEBUG
+
+#define BSP_DIRTY_MEMORY 1
+
+  /*
+   * lm32 requires certain aligment of mbuf because unaligned uint32_t
+   * accesses are not handled properly.
+   */ 
+
+#define CPU_U32_FIX
+
+extern int rtems_tsmac_driver_attach(struct rtems_bsdnet_ifconfig *config,
+				     int attaching);
+
+#define RTEMS_BSP_NETWORK_DRIVER_NAME "TSMAC0"
+#define RTEMS_BSP_NETWORK_DRIVER_ATTACH rtems_tsmac_driver_attach
+
+  /* 
+   * Due to a hardware design error (RJ45 connector with 10baseT magnetics) 
+   * we are forced to use 10baseT mode.
+   */
+
+#define TSMAC_FORCE_10BASET
+
+  /*
+   *  Simple spin delay in microsecond units for device drivers.
+   *  This is very dependent on the clock speed of the target.
+   */
+
+#define rtems_bsp_delay( microseconds ) \
+  { \
+  }
+
+/* functions */
+#if 0
+rtems_isr_entry set_vector(                     /* returns old vector */
+  rtems_isr_entry     handler,                  /* isr routine        */
+  rtems_vector_number vector,                   /* vector number      */
+  int                 type                      /* RTEMS or RAW intr  */
+);
+#endif
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif
+/* end of include file */
Index: c/src/lib/libbsp/lm32/lm32_evr/include/coverhd.h
===================================================================
--- c/src/lib/libbsp/lm32/lm32_evr/include/coverhd.h	(revision e44ffe5e1e029969d90c1e368d3156ac48de76c2)
+++ c/src/lib/libbsp/lm32/lm32_evr/include/coverhd.h	(revision e44ffe5e1e029969d90c1e368d3156ac48de76c2)
@@ -0,0 +1,105 @@
+/*  coverhd.h
+ *
+ *  This include file has defines to represent the overhead associated
+ *  with calling a particular directive from C.  These are used in the
+ *  Timing Test Suite to ignore the overhead required to pass arguments 
+ *  to directives.  On some CPUs and/or target boards, this overhead 
+ *  is significant and makes it difficult to distinguish internal 
+ *  RTEMS execution time from that used to call the directive.
+ *  This file should be updated after running the C overhead timing
+ *  test.  Once this update has been performed, the RTEMS Time Test
+ *  Suite should be rebuilt to account for these overhead times in the
+ *  timing results.
+ *
+ *  NOTE:  If these are all zero, then the times reported include
+ *         all calling overhead including passing of arguments.
+ *
+ *  COPYRIGHT (c) 1989-1998.
+ *  On-Line Applications Research Corporation (OAR).
+ *
+ *  The license and distribution terms for this file may be
+ *  found in the file LICENSE in this distribution or at
+ *  http://www.rtems.com/license/LICENSE.
+ *
+ *  $Id$
+ */
+
+#ifndef __COVERHD_h
+#define __COVERHD_h
+
+#define CALLING_OVERHEAD_INITIALIZE_EXECUTIVE      0
+#define CALLING_OVERHEAD_SHUTDOWN_EXECUTIVE        0
+#define CALLING_OVERHEAD_TASK_CREATE               0
+#define CALLING_OVERHEAD_TASK_IDENT                0
+#define CALLING_OVERHEAD_TASK_START                0
+#define CALLING_OVERHEAD_TASK_RESTART              0
+#define CALLING_OVERHEAD_TASK_DELETE               0
+#define CALLING_OVERHEAD_TASK_SUSPEND              0
+#define CALLING_OVERHEAD_TASK_RESUME               0
+#define CALLING_OVERHEAD_TASK_SET_PRIORITY         0
+#define CALLING_OVERHEAD_TASK_MODE                 0
+#define CALLING_OVERHEAD_TASK_GET_NOTE             0
+#define CALLING_OVERHEAD_TASK_SET_NOTE             0
+#define CALLING_OVERHEAD_TASK_WAKE_WHEN            0
+#define CALLING_OVERHEAD_TASK_WAKE_AFTER           0
+#define CALLING_OVERHEAD_INTERRUPT_CATCH           0
+#define CALLING_OVERHEAD_CLOCK_GET                 0
+#define CALLING_OVERHEAD_CLOCK_SET                 0
+#define CALLING_OVERHEAD_CLOCK_TICK                0
+
+#define CALLING_OVERHEAD_TIMER_CREATE              0
+#define CALLING_OVERHEAD_TIMER_IDENT               0
+#define CALLING_OVERHEAD_TIMER_DELETE              0
+#define CALLING_OVERHEAD_TIMER_FIRE_AFTER          1
+#define CALLING_OVERHEAD_TIMER_FIRE_WHEN           1
+#define CALLING_OVERHEAD_TIMER_RESET               0
+#define CALLING_OVERHEAD_TIMER_CANCEL              0
+#define CALLING_OVERHEAD_SEMAPHORE_CREATE          0
+#define CALLING_OVERHEAD_SEMAPHORE_IDENT           0
+#define CALLING_OVERHEAD_SEMAPHORE_DELETE          0
+#define CALLING_OVERHEAD_SEMAPHORE_OBTAIN          0
+#define CALLING_OVERHEAD_SEMAPHORE_RELEASE         0
+#define CALLING_OVERHEAD_MESSAGE_QUEUE_CREATE      0
+#define CALLING_OVERHEAD_MESSAGE_QUEUE_IDENT       0
+#define CALLING_OVERHEAD_MESSAGE_QUEUE_DELETE      0
+#define CALLING_OVERHEAD_MESSAGE_QUEUE_SEND        0
+#define CALLING_OVERHEAD_MESSAGE_QUEUE_URGENT      0
+#define CALLING_OVERHEAD_MESSAGE_QUEUE_BROADCAST   0
+#define CALLING_OVERHEAD_MESSAGE_QUEUE_RECEIVE     0
+#define CALLING_OVERHEAD_MESSAGE_QUEUE_FLUSH       0
+
+#define CALLING_OVERHEAD_EVENT_SEND                0
+#define CALLING_OVERHEAD_EVENT_RECEIVE             0
+#define CALLING_OVERHEAD_SIGNAL_CATCH              0
+#define CALLING_OVERHEAD_SIGNAL_SEND               0
+#define CALLING_OVERHEAD_PARTITION_CREATE          0
+#define CALLING_OVERHEAD_PARTITION_IDENT           0
+#define CALLING_OVERHEAD_PARTITION_DELETE          0
+#define CALLING_OVERHEAD_PARTITION_GET_BUFFER      0
+#define CALLING_OVERHEAD_PARTITION_RETURN_BUFFER   0
+#define CALLING_OVERHEAD_REGION_CREATE             0
+#define CALLING_OVERHEAD_REGION_IDENT              0
+#define CALLING_OVERHEAD_REGION_DELETE             0
+#define CALLING_OVERHEAD_REGION_GET_SEGMENT        0
+#define CALLING_OVERHEAD_REGION_RETURN_SEGMENT     0
+#define CALLING_OVERHEAD_PORT_CREATE               0
+#define CALLING_OVERHEAD_PORT_IDENT                0
+#define CALLING_OVERHEAD_PORT_DELETE               0
+#define CALLING_OVERHEAD_PORT_EXTERNAL_TO_INTERNAL 0
+#define CALLING_OVERHEAD_PORT_INTERNAL_TO_EXTERNAL 0
+
+#define CALLING_OVERHEAD_IO_INITIALIZE             0
+#define CALLING_OVERHEAD_IO_OPEN                   0
+#define CALLING_OVERHEAD_IO_CLOSE                  0
+#define CALLING_OVERHEAD_IO_READ                   0
+#define CALLING_OVERHEAD_IO_WRITE                  0
+#define CALLING_OVERHEAD_IO_CONTROL                0
+#define CALLING_OVERHEAD_FATAL_ERROR_OCCURRED      0
+#define CALLING_OVERHEAD_RATE_MONOTONIC_CREATE     0
+#define CALLING_OVERHEAD_RATE_MONOTONIC_IDENT      0
+#define CALLING_OVERHEAD_RATE_MONOTONIC_DELETE     0
+#define CALLING_OVERHEAD_RATE_MONOTONIC_CANCEL     0
+#define CALLING_OVERHEAD_RATE_MONOTONIC_PERIOD     0
+#define CALLING_OVERHEAD_MULTIPROCESSING_ANNOUNCE  0
+
+#endif
Index: c/src/lib/libbsp/lm32/lm32_evr/include/irq-config.h
===================================================================
--- c/src/lib/libbsp/lm32/lm32_evr/include/irq-config.h	(revision e44ffe5e1e029969d90c1e368d3156ac48de76c2)
+++ c/src/lib/libbsp/lm32/lm32_evr/include/irq-config.h	(revision e44ffe5e1e029969d90c1e368d3156ac48de76c2)
@@ -0,0 +1,44 @@
+/**
+ * @file
+ *
+ * @ingroup bsp_interrupt
+ *
+ * @brief BSP interrupt support configuration.
+ */
+
+/*
+ * Copyright (c) 2008
+ * Embedded Brains GmbH
+ * Obere Lagerstr. 30
+ * D-82178 Puchheim
+ * Germany
+ * rtems@embedded-brains.de
+ *
+ * The license and distribution terms for this file may be found in the file
+ * LICENSE in this distribution or at http://www.rtems.com/license/LICENSE.
+ */
+
+#ifndef LIBBSP_POWERPC_LM32_IRQ_CONFIG_H
+#define LIBBSP_POWERPC_LM32_IRQ_CONFIG_H
+
+#include <bsp/irq.h>
+
+/**
+ * @addtogroup bsp_interrupt
+ *
+ * @{
+ */
+
+/**
+ * @brief Minimum vector number.
+ */
+#define BSP_INTERRUPT_VECTOR_MIN 0
+
+/**
+ * @brief Maximum vector number.
+ */
+#define BSP_INTERRUPT_VECTOR_MAX 31
+
+/** @} */
+
+#endif /* LIBBSP_POWERPC_LM32_IRQ_CONFIG_H */
Index: c/src/lib/libbsp/lm32/lm32_evr/include/system_conf.h
===================================================================
--- c/src/lib/libbsp/lm32/lm32_evr/include/system_conf.h	(revision e44ffe5e1e029969d90c1e368d3156ac48de76c2)
+++ c/src/lib/libbsp/lm32/lm32_evr/include/system_conf.h	(revision e44ffe5e1e029969d90c1e368d3156ac48de76c2)
@@ -0,0 +1,172 @@
+#ifndef __SYSTEM_CONFIG_H_
+#define __SYSTEM_CONFIG_H_
+
+
+#define FPGA_DEVICE_FAMILY    "ECP2M"
+#define PLATFORM_NAME         "platform1"
+#define USE_PLL               (0)
+#define CPU_FREQUENCY         (75000000)
+
+
+/* FOUND 1 CPU UNIT(S) */
+
+/*
+ * CPU Instance LM32 component configuration
+ */
+#define CPU_NAME "LM32"
+#define CPU_EBA (0x04000000)
+#define CPU_DIVIDE_ENABLED (1)
+#define CPU_SIGN_EXTEND_ENABLED (1)
+#define CPU_MULTIPLIER_ENABLED (1)
+#define CPU_SHIFT_ENABLED (1)
+#define CPU_DEBUG_ENABLED (1)
+#define CPU_HW_BREAKPOINTS_ENABLED (0)
+#define CPU_NUM_HW_BREAKPOINTS (0)
+#define CPU_NUM_WATCHPOINTS (0)
+#define CPU_ICACHE_ENABLED (1)
+#define CPU_ICACHE_SETS (512)
+#define CPU_ICACHE_ASSOC (1)
+#define CPU_ICACHE_BYTES_PER_LINE (16)
+#define CPU_DCACHE_ENABLED (1)
+#define CPU_DCACHE_SETS (512)
+#define CPU_DCACHE_ASSOC (1)
+#define CPU_DCACHE_BYTES_PER_LINE (16)
+#define CPU_DEBA (0x0C000000)
+#define CPU_CHARIO_IN        (1)
+#define CPU_CHARIO_OUT       (1)
+#define CPU_CHARIO_TYPE      "JTAG UART"
+
+/*
+ * gpio component configuration
+ */
+#define GPIO_NAME  "gpio"
+#define GPIO_BASE_ADDRESS  (0x80004000)
+#define GPIO_SIZE  (128)
+#define GPIO_CHARIO_IN        (0)
+#define GPIO_CHARIO_OUT       (0)
+#define GPIO_ADDRESS_LOCK  (1)
+#define GPIO_DISABLE  (0)
+#define GPIO_OUTPUT_PORTS_ONLY  (1)
+#define GPIO_INPUT_PORTS_ONLY  (0)
+#define GPIO_TRISTATE_PORTS  (0)
+#define GPIO_BOTH_INPUT_AND_OUTPUT  (0)
+#define GPIO_DATA_WIDTH  (4)
+#define GPIO_INPUT_WIDTH  (1)
+#define GPIO_OUTPUT_WIDTH  (1)
+#define GPIO_IRQ_MODE  (0)
+#define GPIO_LEVEL  (0)
+#define GPIO_EDGE  (0)
+#define GPIO_EITHER_EDGE_IRQ  (0)
+#define GPIO_POSE_EDGE_IRQ  (0)
+#define GPIO_NEGE_EDGE_IRQ  (0)
+
+/*
+ * uart component configuration
+ */
+#define UART_NAME  "uart"
+#define UART_BASE_ADDRESS  (0x80006000)
+#define UART_SIZE  (128)
+#define UART_IRQ (0)
+#define UART_CHARIO_IN        (1)
+#define UART_CHARIO_OUT       (1)
+#define UART_CHARIO_TYPE      "RS-232"
+#define UART_ADDRESS_LOCK  (1)
+#define UART_DISABLE  (0)
+#define UART_MODEM  (0)
+#define UART_ADDRWIDTH  (5)
+#define UART_DATAWIDTH  (8)
+#define UART_BAUD_RATE  (115200)
+#define UART_IB_SIZE  (4)
+#define UART_OB_SIZE  (4)
+#define UART_BLOCK_WRITE  (1)
+#define UART_BLOCK_READ  (1)
+#define UART_DATA_BITS  (8)
+#define UART_STOP_BITS  (1)
+#define UART_FIFO  (0)
+#define UART_INTERRUPT_DRIVEN  (1)
+
+/*
+ * ebr component configuration
+ */
+#define EBR_NAME  "ebr"
+#define EBR_BASE_ADDRESS  (0x04000000)
+#define EBR_SIZE  (32768)
+#define EBR_IS_READABLE   (1)
+#define EBR_IS_WRITABLE   (1)
+#define EBR_ADDRESS_LOCK  (1)
+#define EBR_DISABLE  (0)
+#define EBR_EBR_DATA_WIDTH  (32)
+#define EBR_INIT_FILE_NAME  "none"
+#define EBR_INIT_FILE_FORMAT  "hex"
+
+/*
+ * ts_mac_core component configuration
+ */
+#define TS_MAC_CORE_NAME  "ts_mac_core"
+#define TS_MAC_CORE_BASE_ADDRESS  (0x80008000)
+#define TS_MAC_CORE_SIZE  (8192)
+#define TS_MAC_CORE_IRQ (2)
+#define TS_MAC_CORE_CHARIO_IN        (0)
+#define TS_MAC_CORE_CHARIO_OUT       (0)
+#define TS_MAC_CORE_ADDRESS_LOCK  (1)
+#define TS_MAC_CORE_DISABLE  (0)
+#define TS_MAC_CORE_STAT_REGS  (1)
+#define TS_MAC_CORE_TXRX_FIFO_DEPTH  (512)
+#define TS_MAC_CORE_MIIM_MODULE  (1)
+#define TS_MAC_CORE_NGO  "l:/mrf/lattice/crio-lm32/platform1/components/ts_mac_top_v27/ipexpress/ts_mac_core/ts_mac_core.ngo"
+#define TS_MAC_CORE_ISPLEVER_PRJ  "l:/mrf/lattice/crio-lm32/criomico.syn"
+
+/*
+ * timer0 component configuration
+ */
+#define TIMER0_NAME  "timer0"
+#define TIMER0_BASE_ADDRESS  (0x80002000)
+#define TIMER0_SIZE  (128)
+#define TIMER0_IRQ (1)
+#define TIMER0_CHARIO_IN        (0)
+#define TIMER0_CHARIO_OUT       (0)
+#define TIMER0_ADDRESS_LOCK  (1)
+#define TIMER0_DISABLE  (0)
+#define TIMER0_PERIOD_NUM  (20)
+#define TIMER0_PERIOD_WIDTH  (32)
+#define TIMER0_WRITEABLE_PERIOD  (1)
+#define TIMER0_READABLE_SNAPSHOT  (1)
+#define TIMER0_START_STOP_CONTROL  (1)
+#define TIMER0_WATCHDOG  (0)
+
+/*
+ * timer1 component configuration
+ */
+#define TIMER1_NAME  "timer1"
+#define TIMER1_BASE_ADDRESS  (0x8000A000)
+#define TIMER1_SIZE  (128)
+#define TIMER1_IRQ (3)
+#define TIMER1_CHARIO_IN        (0)
+#define TIMER1_CHARIO_OUT       (0)
+#define TIMER1_ADDRESS_LOCK  (1)
+#define TIMER1_DISABLE  (0)
+#define TIMER1_PERIOD_NUM  (20)
+#define TIMER1_PERIOD_WIDTH  (32)
+#define TIMER1_WRITEABLE_PERIOD  (1)
+#define TIMER1_READABLE_SNAPSHOT  (1)
+#define TIMER1_START_STOP_CONTROL  (1)
+#define TIMER1_WATCHDOG  (0)
+
+/*
+ * ddr2_sdram component configuration
+ */
+#define DDR2_SDRAM_NAME  "ddr2_sdram"
+#define DDR2_SDRAM_BASE_ADDRESS  (0x08000000)
+#define DDR2_SDRAM_SIZE  (33554432)
+#define DDR2_SDRAM_IS_READABLE   (1)
+#define DDR2_SDRAM_IS_WRITABLE   (1)
+#define DDR2_SDRAM_BST_CNT_READ  (1)
+#define DDR2_SDRAM_ADDRESS_LOCK  (1)
+#define DDR2_SDRAM_DISABLE  (0)
+#define DDR2_SDRAM_NGO  "L:/mrf/lattice/cRIO-LM32/platform1/components/wb_ddr2_ctl_v65/ipexpress/ddr2_sdram/ddr2_sdram.ngo"
+#define DDR2_SDRAM_ISPLEVER_PRJ  "l:/mrf/lattice/crio-lm32/criomico.syn"
+#define DDR2_SDRAM_PARAM_FILE  "ddr_p_eval/$/src/params/ddr_sdram_mem_params.v"
+#define DDR2_SDRAM_MEM_TOP  "ddr_p_eval/$/src/rtl/top/@/ddr_sdram_mem_top.v"
+
+
+#endif /* __SYSTEM_CONFIG_H_ */
Index: c/src/lib/libbsp/lm32/lm32_evr/include/tm27.h
===================================================================
--- c/src/lib/libbsp/lm32/lm32_evr/include/tm27.h	(revision e44ffe5e1e029969d90c1e368d3156ac48de76c2)
+++ c/src/lib/libbsp/lm32/lm32_evr/include/tm27.h	(revision e44ffe5e1e029969d90c1e368d3156ac48de76c2)
@@ -0,0 +1,32 @@
+/*
+ *  tm27.h
+ *
+ *  The license and distribution terms for this file may be
+ *  found in the file LICENSE in this distribution or at
+ *  http://www.rtems.com/license/LICENSE.
+ *
+ *  $Id$
+ */
+
+#ifndef _RTEMS_TMTEST27
+#error "This is an RTEMS internal file you must not include directly."
+#endif
+
+#ifndef __tm27_h
+#define __tm27_h
+
+/*
+ *  Stuff for Time Test 27
+ */
+
+#define MUST_WAIT_FOR_INTERRUPT 0
+
+#define Install_tm27_vector( handler ) set_vector( (handler), 0, 1 )
+
+#define Cause_tm27_intr() /* empty */
+
+#define Clear_tm27_intr() /* empty */
+
+#define Lower_tm27_intr() /* empty */
+
+#endif
Index: c/src/lib/libbsp/lm32/lm32_evr/preinstall.am
===================================================================
--- c/src/lib/libbsp/lm32/lm32_evr/preinstall.am	(revision e44ffe5e1e029969d90c1e368d3156ac48de76c2)
+++ c/src/lib/libbsp/lm32/lm32_evr/preinstall.am	(revision e44ffe5e1e029969d90c1e368d3156ac48de76c2)
@@ -0,0 +1,71 @@
+## Automatically generated by ampolish3 - Do not edit
+
+if AMPOLISH3
+$(srcdir)/preinstall.am: Makefile.am
+	$(AMPOLISH3) $(srcdir)/Makefile.am > $(srcdir)/preinstall.am
+endif
+
+PREINSTALL_DIRS =
+DISTCLEANFILES += $(PREINSTALL_DIRS)
+
+all-local: $(TMPINSTALL_FILES)
+
+TMPINSTALL_FILES =
+CLEANFILES = $(TMPINSTALL_FILES)
+
+all-am: $(PREINSTALL_FILES)
+
+PREINSTALL_FILES =
+CLEANFILES += $(PREINSTALL_FILES)
+
+$(PROJECT_LIB)/$(dirstamp):
+	@$(MKDIR_P) $(PROJECT_LIB)
+	@: > $(PROJECT_LIB)/$(dirstamp)
+PREINSTALL_DIRS += $(PROJECT_LIB)/$(dirstamp)
+
+$(PROJECT_INCLUDE)/$(dirstamp):
+	@$(MKDIR_P) $(PROJECT_INCLUDE)
+	@: > $(PROJECT_INCLUDE)/$(dirstamp)
+PREINSTALL_DIRS += $(PROJECT_INCLUDE)/$(dirstamp)
+
+$(PROJECT_INCLUDE)/bsp/$(dirstamp):
+	@$(MKDIR_P) $(PROJECT_INCLUDE)/bsp
+	@: > $(PROJECT_INCLUDE)/bsp/$(dirstamp)
+PREINSTALL_DIRS += $(PROJECT_INCLUDE)/bsp/$(dirstamp)
+
+$(PROJECT_LIB)/bsp_specs: bsp_specs $(PROJECT_LIB)/$(dirstamp)
+	$(INSTALL_DATA) $< $(PROJECT_LIB)/bsp_specs
+PREINSTALL_FILES += $(PROJECT_LIB)/bsp_specs
+
+$(PROJECT_INCLUDE)/bsp.h: include/bsp.h $(PROJECT_INCLUDE)/$(dirstamp)
+	$(INSTALL_DATA) $< $(PROJECT_INCLUDE)/bsp.h
+PREINSTALL_FILES += $(PROJECT_INCLUDE)/bsp.h
+
+$(PROJECT_INCLUDE)/tm27.h: include/tm27.h $(PROJECT_INCLUDE)/$(dirstamp)
+	$(INSTALL_DATA) $< $(PROJECT_INCLUDE)/tm27.h
+PREINSTALL_FILES += $(PROJECT_INCLUDE)/tm27.h
+
+$(PROJECT_INCLUDE)/bspopts.h: include/bspopts.h $(PROJECT_INCLUDE)/$(dirstamp)
+	$(INSTALL_DATA) $< $(PROJECT_INCLUDE)/bspopts.h
+PREINSTALL_FILES += $(PROJECT_INCLUDE)/bspopts.h
+
+$(PROJECT_INCLUDE)/bsp/bootcard.h: ../../shared/include/bootcard.h $(PROJECT_INCLUDE)/bsp/$(dirstamp)
+	$(INSTALL_DATA) $< $(PROJECT_INCLUDE)/bsp/bootcard.h
+PREINSTALL_FILES += $(PROJECT_INCLUDE)/bsp/bootcard.h
+
+$(PROJECT_INCLUDE)/coverhd.h: include/coverhd.h $(PROJECT_INCLUDE)/$(dirstamp)
+	$(INSTALL_DATA) $< $(PROJECT_INCLUDE)/coverhd.h
+PREINSTALL_FILES += $(PROJECT_INCLUDE)/coverhd.h
+
+$(PROJECT_INCLUDE)/system_conf.h: include/system_conf.h $(PROJECT_INCLUDE)/$(dirstamp)
+	$(INSTALL_DATA) $< $(PROJECT_INCLUDE)/system_conf.h
+PREINSTALL_FILES += $(PROJECT_INCLUDE)/system_conf.h
+
+$(PROJECT_LIB)/start.$(OBJEXT): start.$(OBJEXT) $(PROJECT_LIB)/$(dirstamp)
+	$(INSTALL_DATA) $< $(PROJECT_LIB)/start.$(OBJEXT)
+TMPINSTALL_FILES += $(PROJECT_LIB)/start.$(OBJEXT)
+
+$(PROJECT_LIB)/linkcmds: startup/linkcmds $(PROJECT_LIB)/$(dirstamp)
+	$(INSTALL_DATA) $< $(PROJECT_LIB)/linkcmds
+PREINSTALL_FILES += $(PROJECT_LIB)/linkcmds
+
Index: c/src/lib/libbsp/lm32/lm32_evr/startup/linkcmds
===================================================================
--- c/src/lib/libbsp/lm32/lm32_evr/startup/linkcmds	(revision e44ffe5e1e029969d90c1e368d3156ac48de76c2)
+++ c/src/lib/libbsp/lm32/lm32_evr/startup/linkcmds	(revision e44ffe5e1e029969d90c1e368d3156ac48de76c2)
@@ -0,0 +1,287 @@
+OUTPUT_FORMAT("elf32-lm32", "elf32-lm32",
+              "elf32-lm32")
+OUTPUT_ARCH(lm32)
+ENTRY(_start)
+/* Do we need any of these for elf?
+   __DYNAMIC = 0;    */
+
+/*
+ * Declare some sizes. Heap is sized at whatever ram space is left.
+ */
+RamBase = DEFINED(RamBase) ? RamBase : 0x08000000;
+RamSize = DEFINED(RamSize) ? RamSize : 32M;
+HeapSize = DEFINED(HeapSize) ? HeapSize : 2M;
+_StackSize = DEFINED(_StackSize) ? _StackSize : 0x2000;
+
+PROVIDE (__stack = 0);
+MEMORY {
+	ebr	: ORIGIN = 0x04000000 , LENGTH = 32k
+	sdram   : ORIGIN = 0x08000000 , LENGTH = 32M
+}
+SECTIONS
+{
+  .boot :
+  {
+    KEEP (*(.boot))
+  } > ebr
+
+  /* Read-only sections, merged into text segment: */
+  .interp   : { *(.interp) }	> sdram
+  .hash           : { *(.hash)          }	> sdram
+  .dynsym         : { *(.dynsym)                }	> sdram
+  .dynstr         : { *(.dynstr)                }	> sdram
+  .gnu.version   : { *(.gnu.version)      }	> sdram
+  .gnu.version_d   : { *(.gnu.version_d)  }	> sdram
+  .gnu.version_r   : { *(.gnu.version_r)  }	> sdram
+  .rela.text     :
+    { *(.rela.text) *(.rela.gnu.linkonce.t*) }	> sdram
+  .rela.data     :
+    { *(.rela.data) *(.rela.gnu.linkonce.d*) }	> sdram
+  .rela.rodata   :
+    { *(.rela.rodata*) *(.rela.gnu.linkonce.r*) }	> sdram
+  .rela.got       : { *(.rela.got)      }	> sdram
+  .rela.got1      : { *(.rela.got1)     }	> sdram
+  .rela.got2      : { *(.rela.got2)     }	> sdram
+  .rela.ctors     : { *(.rela.ctors)    }	> sdram
+  .rela.dtors     : { *(.rela.dtors)    }	> sdram
+  .rela.init      : { *(.rela.init)     }	> sdram
+  .rela.fini      : { *(.rela.fini)     }	> sdram
+  .rela.bss       : { *(.rela.bss)      }	> sdram
+  .rela.plt       : { *(.rela.plt)      }	> sdram
+  .rela.sdata     : { *(.rela.sdata)    }	> sdram
+  .rela.sbss      : { *(.rela.sbss)     }	> sdram
+  .rela.sdata2    : { *(.rela.sdata2)   }	> sdram
+  .rela.sbss2     : { *(.rela.sbss2)    }	> sdram
+  .rela.dyn       : { *(.rela.dyn)      }	> sdram
+
+  .init		  : { KEEP(*(.init))		} > sdram
+
+  .text      :	
+  {
+    *(.text*)	
+
+    /*
+     * Special FreeBSD sysctl sections.
+     */
+    . = ALIGN (16);
+    __start_set_sysctl_set = .;
+    *(set_sysctl_*);
+    __stop_set_sysctl_set = ABSOLUTE(.);
+    *(set_domain_*);
+    *(set_pseudo_*);
+
+    /* .gnu.warning sections are handled specially by elf32.em.  */
+    *(.gnu.warning)
+    *(.gnu.linkonce.t*)
+  }  > sdram
+
+  .fini		  : { _fini = .; KEEP(*(.fini))	} > sdram
+
+  .rodata         : { *(.rodata*) *(.gnu.linkonce.r*) }	> sdram
+  .rodata1        : { *(.rodata1) }	> sdram
+
+  /* Adjust the address for the data segment.  We want to adjust up to
+     the same address within the page on the next page up.  */
+  . = ALIGN(0x10000) + (. & (0x10000 - 1));
+  /* Ensure the __preinit_array_start label is properly aligned.  We
+     could instead move the label definition inside the section, but
+     the linker would then create the section even if it turns out to
+     be empty, which isn't pretty.  */
+  . = ALIGN(32 / 8);
+  PROVIDE (__preinit_array_start = .);
+  .preinit_array     : { *(.preinit_array) } >sdram
+  PROVIDE (__preinit_array_end = .);
+  PROVIDE (__init_array_start = .);
+  .init_array     : { *(.init_array) } >sdram
+  PROVIDE (__init_array_end = .);
+  PROVIDE (__fini_array_start = .);
+  .fini_array     : { *(.fini_array) } >sdram
+  PROVIDE (__fini_array_end = .);
+
+/* _SDA2_BASE_ = __SDATA2_START__ + 0x8000; */
+  .sdata2         : { *(.sdata2 .sdata2.* .gnu.linkonce.s2.*) } >sdram
+  .sbss2          : { *(.sbss2 .sbss2.* .gnu.linkonce.sb2.*) 
+                        /* avoid empty sdata2/sbss2 area -- __eabi would not set up r2
+                         * which may be important if run-time loading is used
+                         */
+                     . += 1;
+                    } >sdram
+  .eh_frame	  : { *.(eh_frame)		} >sdram
+
+  /* NOTE: if the BSP uses page tables, the correctness of
+   *       '_etext' (and __DATA_START__) is CRUCIAL - otherwise,
+   *       an invalid mapping may result!!!
+   */
+  _etext = .;
+  PROVIDE (etext = .);
+
+  /* Adjust the address for the data segment.  We want to adjust up to
+     the same address within the page on the next page up.  It would
+     be more correct to do this:
+       . = ALIGN(0x40000) + (ALIGN(8) & (0x40000 - 1));
+     The current expression does not correctly handle the case of a
+     text segment ending precisely at the end of a page; it causes the
+     data segment to skip a page.  The above expression does not have
+     this problem, but it will currently (2/95) cause BFD to allocate
+     a single segment, combining both text and data, for this case.
+     This will prevent the text segment from being shared among
+     multiple executions of the program; I think that is more
+     important than losing a page of the virtual address space (note
+     that no actual memory is lost; the page which is skipped can not
+     be referenced).  */
+  . = ALIGN(0x1000);
+ .data ALIGN(0x1000) :
+  {
+   /* NOTE: if the BSP uses page tables, the correctness of
+    *       '__DATA_START__' (and _etext) is CRUCIAL - otherwise,
+    *       an invalid mapping may result!!!
+    */
+	PROVIDE(__DATA_START__ = ABSOLUTE(.) );
+    *(.data .data.* .gnu.linkonce.d*)	
+    SORT(CONSTRUCTORS)
+  } > sdram
+  .data1   : { *(.data1) }	> sdram
+  PROVIDE (__EXCEPT_START__ = .);
+  .gcc_except_table   : { *(.gcc_except_table) } > sdram
+  PROVIDE (__EXCEPT_END__ = .);
+  .got1           : { *(.got1) }	> sdram
+  /* Put .ctors and .dtors next to the .got2 section, so that the pointers
+     get relocated with -mrelocatable. Also put in the .fixup pointers.
+     The current compiler no longer needs this, but keep it around for 2.7.2  */
+                PROVIDE (_GOT2_START_ = .);
+  .got2           :  { *(.got2) }	> sdram
+  .dynamic        : { *(.dynamic) }	> sdram
+
+  .ctors          :
+  {
+    /* gcc uses crtbegin.o to find the start of
+       the constructors, so we make sure it is
+       first.  Because this is a wildcard, it
+       doesn't matter if the user does not
+       actually link against crtbegin.o; the
+       linker won't look for a file to match a
+       wildcard.  The wildcard also means that it
+       doesn't matter which directory crtbegin.o
+       is in.  */
+    KEEP (*crtbegin.o(.ctors))
+    /* We don't want to include the .ctor section from
+       from the crtend.o file until after the sorted ctors.
+       The .ctor section from the crtend file contains the
+       end of ctors marker and it must be last */
+    KEEP (*(EXCLUDE_FILE (*crtend.o ) .ctors))
+    KEEP (*(SORT(.ctors.*)))
+    KEEP (*(.ctors))
+  } > sdram
+  .dtors          :
+  {
+    KEEP (*crtbegin.o(.dtors))
+    KEEP (*(EXCLUDE_FILE (*crtend.o ) .dtors))
+    KEEP (*(SORT(.dtors.*)))
+    KEEP (*(.dtors))
+  } > sdram
+
+
+                PROVIDE (_FIXUP_START_ = .);
+  .fixup          : { *(.fixup) }	> sdram
+                PROVIDE (_FIXUP_END_ = .);
+                PROVIDE (_GOT2_END_ = .);
+                PROVIDE (_GOT_START_ = .);
+
+  .got            : { *(.got) }	> sdram
+  .got.plt        : { *(.got.plt) }	> sdram
+
+                PROVIDE (_GOT_END_ = .);
+
+  .jcr            : { KEEP (*(.jcr)) } > sdram
+
+  /* We want the small data sections together, so single-instruction offsets
+     can access them all, and initialized data all before uninitialized, so
+     we can shorten the on-disk segment size.  */
+/* _SDA_BASE_ = __SDATA_START__ + 0x8000; */
+  .sdata	  : { *(.sdata*) *(.gnu.linkonce.s.*)	} >sdram
+  _edata  =  .;
+  _gp = .;
+  PROVIDE (edata = .);
+  .sbss      :
+  {
+    _clear_start = .;
+    PROVIDE (__sbss_start = .);
+    *(.dynsbss)
+    *(.sbss* .gnu.linkonce.sb.*)
+    *(.scommon)
+    /* avoid empty sdata/sbss area -- __eabi would not set up r13
+     * which may be important if run-time loading is used
+     */
+    . += 1;
+    . = ALIGN(16);
+    PROVIDE (__sbss_end = .);
+  } > sdram
+  .plt   : { *(.plt) }	> sdram
+  .bss       :
+  {
+   PROVIDE (__bss_start = .);
+   *(.dynbss)
+   *(.bss .bss* .gnu.linkonce.b*)
+   *(COMMON)
+  . = ALIGN(16);
+  _end = . ;
+  __rtems_end = . ;
+  PROVIDE (end = .);
+
+  WorkAreaBase = .;
+
+    . += _StackSize;
+    . = ALIGN (16);
+    _stack_init = .;
+    _clear_end = .;
+    _fstack = .;
+
+  } > sdram
+
+
+  /DISCARD/ : 
+  {
+    *(.comment)
+  }
+
+
+  /* Stabs debugging sections.  */
+  .stab 0 : { *(.stab) }
+  .stabstr 0 : { *(.stabstr) }
+  .stab.excl 0 : { *(.stab.excl) }
+  .stab.exclstr 0 : { *(.stab.exclstr) }
+  .stab.index 0 : { *(.stab.index) }
+  .stab.indexstr 0 : { *(.stab.indexstr) }
+  .comment 0 : { *(.comment) }
+
+  /* DWARF debug sections.
+     Symbols in the DWARF debugging sections are relative to the beginning
+     of the section so we begin them at 0.  */
+  /* DWARF 1 */
+  .debug          0 : { *(.debug) }
+  .line           0 : { *(.line) }
+  
+  /* GNU DWARF 1 extensions */
+  .debug_srcinfo  0 : { *(.debug_srcinfo) }
+  .debug_sfnames  0 : { *(.debug_sfnames) }
+  
+  /* DWARF 1.1 and DWARF 2 */
+  .debug_aranges  0 : { *(.debug_aranges) }
+  .debug_pubnames 0 : { *(.debug_pubnames) }
+  
+  /* DWARF 2 */
+  .debug_info     0 : { *(.debug_info) }
+  .debug_abbrev   0 : { *(.debug_abbrev) }
+  .debug_line     0 : { *(.debug_line) }
+  .debug_frame    0 : { *(.debug_frame) }
+  .debug_str      0 : { *(.debug_str) }
+  .debug_loc      0 : { *(.debug_loc) }
+  .debug_macinfo  0 : { *(.debug_macinfo) }
+  
+  /* SGI/MIPS DWARF 2 extensions */
+  .debug_weaknames 0 : { *(.debug_weaknames) }
+  .debug_funcnames 0 : { *(.debug_funcnames) }
+  .debug_typenames 0 : { *(.debug_typenames) }
+  .debug_varnames  0 : { *(.debug_varnames) }
+  /* These must appear regardless of  .  */
+}
